unit mkstmain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  SPIs, StdCtrls, ExtCtrls, MkstAchv;

type
  TMkstMainForm = class(TForm)
    ScrollBox1: TScrollBox;
    Image1: TImage;
    Panel1: TPanel;
    ListBox1: TListBox;
    Panel2: TPanel;
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    SPIs1: TSPIs;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
  private
    { Private 錾 }
    FArchive: TMakeshiftArchive;

    procedure ListBox1AddArchiveFileNames;
  public
    { Public 錾 }
  end;

var
  MkstMainForm: TMkstMainForm;

implementation

uses
  SPIBmp;

{$R *.DFM}

procedure TMkstMainForm.FormCreate(Sender: TObject);
begin
  FArchive := TMakeshiftArchive.Create;
end;

procedure TMkstMainForm.FormDestroy(Sender: TObject);
begin
  FArchive.Free;
end;

procedure TMkstMainForm.Button1Click(Sender: TObject);
begin
  with OpenDialog1 do begin
    Filter := TMakeshiftArchive.Filter;
    if Execute then begin
      FArchive.LoadFromFile(FileName);
      ListBox1AddArchiveFileNames;
    end;
  end;
end;

procedure TMkstMainForm.ListBox1Click(Sender: TObject);
var
  spiBitmap: TSPIBitmap;
  stream: TMemoryStream;
  archive: TMakeshiftArchive;
begin
  spiBitmap := nil;
  stream := nil;
  try
    spiBitmap := TSPIBitmap.Create;
    stream := TMemoryStream.Create;

    FArchive.SaveToStream(ListBox1.ItemIndex, stream);
    try
//      FArchive.SaveToGraphic(ListBox1.ItemIndex, spiBitmap);
      stream.Position := 0;
      spiBitmap.LoadFromStreamWithName(stream,
        FArchive.FileNames[ListBox1.ItemIndex]);
      Image1.Picture.Assign(spiBitmap);
    except
      archive := TMakeshiftArchive.Create;
      try
        archive.LoadFromStream(stream,  FArchive.FileNames[ListBox1.ItemIndex]);
        FArchive.Free;
        FArchive := archive;
        archive := nil;
        ListBox1AddArchiveFileNames;
      except
        archive.Free;
      end;
    end;
  finally
    spiBitmap.Free;
    stream.Free;
  end;
end;

procedure TMkstMainForm.ListBox1AddArchiveFileNames;
var
  fileIdx: Integer;
begin
  with ListBox1.Items do begin
    BeginUpdate;
    try
      Clear;
      for fileIdx := 0 to FArchive.FileCount-1 do begin
        Add(FArchive.FileNames[fileIdx]);
      end;
    finally
      EndUpdate;
    end;
  end;
end;

end.
