//	A[JCoR|[lg for Delphi/C++Builder
// Common Archivers Component for Delphi/C++Builder
// Copyright(C) NORG1964/M.Yoneda 1997,1998,1999,2000
//
//	{W[	ARCHIVES.PAS
//
// v1.15:|@\J
// v1.16:ɍ쐬̉LIvVT|[g^]p@\ƂČJ
//	      -a1    FBt@CEVXet@CΏۂƂ
//	      -r1    Fw肳ꂽ}XÑt@CċAIɌ
//	      -r2    Ft@CXgɃfBNĝ݂w肳ꂽ *.* ⊮
//	      -jo/jobFkt@C̓t肷
//	      -ji1   FZt@CɂɋL^
// v1.17:Find n function ́u`IȃoOvւ̑΍
//       BfBNgEVXefBNgΏۂɂȂȂs̏C
//       ċA̍|̂P
//       FindClose C
// v1.20:MakeFileName  interface ɒǉ
// v1.21:GetLastChar ̎኱ύX( Delphi 2 Ή )
//       DirectoryExists ̎ύX( Delphi 4 Ή )
// v1.24:GetLastChar  AnsiLastChar ɉ
//       Delphi 2 p AnsiPos ǉ
// v1.30:e\bh FileList ̌^ύX
//       tB^sProgressCxg@\ǉ
// v1.31:tB^łQN̊gTwoDigitYearCenturyWindowg悤ύX
//       tB^ jo/job ւ yyyymmdd `t󂯂悤ɂ
//       tB^ jx IvṼT|[gJn
// v1.32:tB^ jo/job ւ'l'̎wɑΉ('l'𖳎邾)
//       QN̊g C++Builder 3 ɑΉ
// v1.33:ExtractFileName ̎̌C
//       D2 p LastDelimiter ̎ύX
// v1.34:fBNgӎǉ
// v1.37:Delphi 6 ɑΉ
// v1.38:tB^ɋIɑ΃pXL^@\ǉ ( jf-2 )
// v1.47:FileTimeToDateTime ֐ isUTC ǉ
//       LocalDosDateTimeToFileTime ֐̎ǉ
//
unit FILTERS;

interface

{$INCLUDE VERSION.INC}

uses
	Windows,
	Classes,
{$IFDEF D6_OR_LATER}
	Variants,
{$ENDIF}
	Archives;

function LocalDosDateTimeToFileTime( wDosDate,wDosTime:WORD;var FileTime:TFileTime ):BOOL;
function DosDateTimeToDateTime( wDosDate,wDosTime:WORD ):TDateTime;
function FileTimeToDateTime( FileTime:TFileTime;isUTC:boolean ):TDateTime;
function MakeFileName( FilePath,FileName:string ):string;
{$IFDEF VER90} // Delphi 2 ?
function SystemTimeToDateTime( const SystemTime:TSystemTime ):TDateTime;
function AnsiPos( const SubStr,S:string ):Integer;
function AnsiLastChar( const S:string ):Char;
function LastDelimiter( const Delimiters,S:string ):Integer;
procedure Assert( expr:Boolean;const msg:string );
{$ENDIF}

{$IFDEF D3_OR_EARLIER}
var
	TwoDigitYearCenturyWindow:	WORD;
{$ENDIF}

type
	TProgressProc = procedure( State:UINT;lpEis:LPExtractingInfoEx;var Abort:boolean ) of object;

function PackFileFilter( ProgressProc:TProgressProc;Options:TArchiverOptions;BaseDir:string;FileList:array of const;var AbortFilter:boolean ):TStrings;
function ExpandTwoDigitYear( TwoDigitYear:integer ):integer;

implementation

uses
{$IFDEF VER90}
	MBUtils,  	//	for GetLastChar
{$ENDIF}
//	FileCtrl,	//	DirectoryExists ̂߂g Forms 
	SysUtils;

function CurrentYear:Word;
var
	SystemTime: TSystemTime;
begin
	GetLocalTime( SystemTime );
	Result := SystemTime.wYear;
end;

function ExpandTwoDigitYear( TwoDigitYear:integer ):integer;
var
	CenturyBasePivot:	integer;		//	Ƃs{bgN
begin
	Result := TwoDigitYear;
	CenturyBasePivot := CurrentYear - TwoDigitYearCenturyWindow;
	Inc( Result,CenturyBasePivot div 100 * 100 );
	if( TwoDigitYearCenturyWindow > 0 )and( Result < CenturyBasePivot ) then Inc( Result,100 );
end;

function DirectoryExists( const FileName:string ):Boolean;
var
	FileAttr:	LongInt;
begin
	Result := False;
	FileAttr := GetFileAttributes( PChar( FileName ));
	if FileAttr = -1 then exit;
	Result := ( FileAttr and FILE_ATTRIBUTE_DIRECTORY ) <> 0;
end;

function FileTimeToDateTime( FileTime:TFileTime;isUTC:boolean ):TDateTime;
var
	LocalFileTime: TFileTime;
	SystemTime:		TSystemTime;
begin
	result := 0;
	if( FileTime.dwLowDateTime = 0 ) and ( FileTime.dwHighDateTime=0 ) then exit;
	if isUTC
	then begin
		FileTimeToLocalFileTime( FileTime,LocalFileTime );
	end else begin
		LocalFileTime := FileTime;
	end;
	FileTimeToSystemTime( LocalFileTime,SystemTime );
	result := SystemTimeToDateTime( SystemTime );
end;

function DosDateTimeToDateTime( wDosDate,wDosTime:WORD ):TDateTime;
var
	DosDateTime:	integer;
	DateTime:		TDateTime;
begin
	LongRec( DosDateTime ).Hi := wDosDate;
	LongRec( DosDateTime ).Lo := wDosTime;
	if DosDateTime <> 0
	then begin
		try
			DateTime := FileDateToDateTime( DosDateTime )
		except
			DateTime := 0;
		end;
	end else begin
		DateTime := 0;
	end;
	result := DateTime;
end;

function LocalDosDateTimeToFileTime( wDosDate,wDosTime:WORD;var FileTime:TFileTime ):BOOL;
var
	LocalFileTime:	TFileTime;
begin
	if( wDosDate=0 )and( wDosTime=0 )
	then begin
		FileTime.dwLowDateTime  := 0;
		FileTime.dwHighDateTime := 0;
		result := true;
		exit;
	end;
	result := DosDateTimeToFileTime( wDosDate,wDosTime,LocalFileTime ) and LocalFileTimeToFileTime( LocalFileTime,FileTime );
end;

{$IFDEF VER90}
function SystemTimeToDateTime( const SystemTime:TSystemTime ):TDateTime;
begin
	with SystemTime do
		Result := EncodeDate( wYear,wMonth,wDay ) +
					 EncodeTime( wHour,wMinute,wSecond,wMilliSeconds );
end;

function AnsiPos( const SubStr,S:string ):integer;
begin
	Result := MBUtils.MBPos( SubStr,S );
end;

function AnsiLastChar( const S:string ):Char;
begin
	Result := MBUtils.GetLastChar( S );
end;

function LastDelimiter( const Delimiters,S:string ):Integer;
var
	T:	PChar;
	D:	PChar;
	R:	PChar;
begin
	T := PChar( S );
	R := T + Length( S );
	D := PChar( Delimiters );
	while R > T do begin
		if( R^ <> #0 )and( StrScan( D,R^ ) <> nil )
		then begin
			if not isMBSTrail( T,R ) then break;
			Dec( R );
		end;
		Dec( R );
	end;
	Result := R - T;
end;

{$ENDIF}

//	W ExtractFileName ɉA'/' pX̋؂ƔF
function ExtractFileName( const FileName:string ):string;
var
	I:	Integer;
begin
	I := LastDelimiter( '/\:',FileName );
	Result := Copy( FileName,I+1,MaxInt );
end;

function MakeFileName( FilePath,FileName:string ):string;
begin
	if Length( FilePath ) > 0
	then begin
		if AnsiLastChar( FilePath )='\'
		then Result := FilePath +		FileName
		else Result := FilePath + '\' + FileName;
	end else begin
		Result := FileName;
	end;
end;

function DecodeArcOptDate( yymmddhhmmss,hhmmss:string ):TDateTime;
var
	Size:		integer;
	wYear:	word;
	wMonth:	word;
	wDay:		word;
	wHour:	word;
	wMinute:	word;
	wSecond:	word;
begin
	Size := Length( yymmddhhmmss );

	if( Size > 1 )and( yymmddhhmmss[1] = 'l' )
	then begin
		yymmddhhmmss := Copy( yymmddhhmmss,2,99 );
		Size := Length( yymmddhhmmss );
	end;

	Result := 0;
	if( Size = 6 ) or ( Size = 12 )
	then begin
		wYear  := ExpandTwoDigitYear( StrToInt( Copy( yymmddhhmmss, 1,2 )));
		wMonth := StrToInt( Copy( yymmddhhmmss, 3,2 ));
		wDay   := StrToInt( Copy( yymmddhhmmss, 5,2 ));
		if Size = 12 then hhmmss := Copy( yymmddhhmmss, 7,6 );
		wHour  := StrToInt( Copy( hhmmss, 1,2 ));
		wMinute:= StrToInt( Copy( hhmmss, 3,2 ));
		wSecond:= StrToInt( Copy( hhmmss, 5,2 ));
		Result := EncodeDate( wYear,wMonth,wDay )
				  + EncodeTime( wHour,wMinute,wSecond,0 );
	end;
	if( Size = 8 ) or ( Size = 14 )
	then begin
		wYear   := StrToInt( Copy( yymmddhhmmss, 1,4 ));
		wMonth  := StrToInt( Copy( yymmddhhmmss, 5,2 ));
		wDay    := StrToInt( Copy( yymmddhhmmss, 7,2 ));
//		wYear   := ExpandTwoDigitYear( wYear );	Sw̎͊gȂ
		if Size = 14 then hhmmss := Copy( yymmddhhmmss, 9,6 );
		wHour   := StrToInt( Copy( hhmmss, 1,2 ));
		wMinute := StrToInt( Copy( hhmmss, 3,2 ));
		wSecond := StrToInt( Copy( hhmmss, 5,2 ));
		Result  := EncodeDate( wYear,wMonth,wDay )
				   + EncodeTime( wHour,wMinute,wSecond,0 );
	end;
end;

function HasWildCard( FileName:string ):boolean;
begin
	result := ( Pos( '?',FileName ) > 0 ) or ( Pos( '*',FileName ) > 0 )
end;

//	Find n function ́u`IȖvւ̑΍
//	̃R[h̓oOC㒼ɍ폜Ȃ΂ȂȂ
//	[ADelphi 4 ł܂ĂȂEEE(=_=) 98/10/31
//	Delphi 4 Update 2 ŒIEEEEEE
//	VERXXX   Update 2 ƃIWi̋ʂȂA
//	̂܂܂łeȂ̂őo[Ŵ߂ɂc 98/12/16
function FindFirst( const Path:string;Attr:Integer;var F:TSearchRec ):Integer;
begin
	Result := SysUtils.FindFirst( Path,Attr,F );
	if Result <> 0 then F.FindHandle := INVALID_HANDLE_VALUE;
end;

function MakeFileList( Options:TArchiverOptions;BaseDir:string;SrcFileList,ExclusiveFileList:TStrings;DoProgress:TProgressProc;var AbortFilter:boolean;ExpandEmptyList:boolean ):TStrings;
var
	NewFileList:		TStringList;
	DateFrom:			TDateTime;
	DateTo:				TDateTime;
	ItemIndex:			integer;
	FileName:			string;
	FilePath:			string;
	FileMask:			string;
	FileAttr:			integer;
	ExtractingInfo:	TExtractingInfoEx;

	function CheckFileDate( FileDate:TDateTime ):boolean;
	begin
		Result := false;
		if ( DateFrom <> 0 ) and ( FileDate < DateFrom ) then exit;
		if ( DateTo	  <> 0 ) and ( FileDate > DateTo   ) then exit;
		result := true;
	end;
	procedure ProgressCallback( FileName:string );
	begin
		if not Assigned( DoProgress ) then exit;
		StrLCopy( ExtractingInfo.exinfo.szSourceFileName,PChar( FileName ),sizeof( ExtractingInfo.exinfo.szSourceFileName ));
		DoProgress( $805,@ExtractingInfo,AbortFilter );
	end;
	procedure LoadFileList( Path,Mask:string );
	var
		SearchRec:	TSearchRec;
		FileDate:	TDateTime;
		Result:		Integer;
		procedure AddItem( FileName:string );
		var
			PrevCount:	integer;
		begin
			if( Assigned( ExclusiveFileList )and( ExclusiveFileList.IndexOf( FileName ) >= 0 )) then exit;
//			if NewFileList.IndexOf( FileName ) >= 0 then exit;
			PrevCount := NewFileList.Count;

			NewFileList.Add( FileName );

			if NewFileList.Count > PrevCount
			then begin
				ProgressCallBack( FileName );
			end;
		end;
		function MakePackFileName:string;
		begin
			if ( Options.ji < 1 )or( SearchRec.FindData.cAlternateFileName[0]=#0 )
			then Result := SearchRec.FindData.cFileName
			else Result := SearchRec.FindData.cAlternateFileName;
			Result := MakeFileName( Path,Result );
{$IFNDEF VER90}
			if( Options.jf = -2 )and( BaseDir <> '' )
			then Result := ExtractRelativePath( BaseDir,Result );
{$ENDIF}
		end;
	begin
//		if Options.a >= 2 then AddItem( Path );	tar ŏdi[邽߃T|[g~

		Result := FindFirst( MakeFileName( Path,Mask ),FileAttr,SearchRec );
		try
			while Result=0 do begin
				if AbortFilter then exit;
				if( SearchRec.Name <> '..' ) and ( SearchRec.Name <> '.' )
				then begin
					FileDate := FileTimeToDateTime( SearchRec.FindData.ftLastWriteTime,true );
					if CheckFileDate( FileDate )
					then begin
						AddItem( MakePackFileName );
					end;
				end;
				Result := FindNext( SearchRec );
			end;
		finally
			FindClose( SearchRec );
		end;

		if( Options.r < 1 ) then exit;
		if( Options.p > 0 ) and ( not HasWildCard( Mask )) then exit;

		Result := FindFirst( MakeFileName( Path,'*.*' ),faDirectory or faHidden or faSysFile,SearchRec );
		try
			while Result=0 do begin
				if AbortFilter then exit;
				if( SearchRec.Attr and faDirectory )<> 0
				then begin
					if( SearchRec.Name <> '..' )and( SearchRec.Name <> '.' )
					then begin
						LoadFileList( MakePackFileName,Mask );
					end;
				end;
				Result := FindNext( SearchRec );
			end;
		finally
			FindClose( SearchRec );
		end;
	end;
begin
	FillChar( ExtractingInfo,sizeof( ExtractingInfo ),#0 );

	NewFileList := TStringList.Create;
	try
		NewFileList.Duplicates := dupIgnore;	//	Qdo^Ȃ
		NewFileList.Sorted	  := True;

		DateFrom := DecodeArcOptDate( Options.jo ,'000000' );
		DateTo   := DecodeArcOptDate( Options.job,'235959' );
		NewFileList.BeginUpdate;

		FileAttr := faReadOnly + faArchive;
		if Options.a >= 1 then FileAttr := FileAttr + faHidden + faSysFile;
//		if Options.a >= 2 then FileAttr := FileAttr + faDirectory;
		if( SrcFileList = nil ) or ( SrcFileList.Count=0 )
		then begin
			if ExpandEmptyList then LoadFileList( '','*.*' );
		end else begin
			for ItemIndex := 0 to SrcFileList.Count-1 do begin
				if AbortFilter then break;
				FileName := SrcFileList[ItemIndex];
				if( Options.r > 1 ) and DirectoryExists( FileName )
				then begin
					FilePath := FileName;
					FileMask := '*.*'
				end else begin
					FilePath := ExtractFileDir ( SrcFileList[ItemIndex] );
					FileMask := ExtractFileName( SrcFileList[ItemIndex] );
				end;
				LoadFileList( FilePath,FileMask );
			end;
		end;
		NewFileList.EndUpdate;

		Result := NewFileList;
	except
		NewFileList.Free;
		raise;
	end;
end;

procedure ChDirEx( Dir:string;var OrgCurDir1:string;var OrgCurDir2:string );
begin
	if Dir='' then exit;
	GetDir( 0,OrgCurDir2 );		//	JghCuL^
	if Dir[2]=':'					//	hCuw肠H
	then begin						//	ChDirhCũJgfBNgL^
		GetDir( Ord( Dir[1] )-Ord( 'A' )+1,OrgCurDir1 );
	end else begin
		OrgCurDir1 := '';
	end;
	System.ChDir( Dir );
end;

function PackFileFilter( ProgressProc:TProgressProc;Options:TArchiverOptions;BaseDir:string;FileList:array of const;var AbortFilter:boolean ):TStrings;
var
	TempFileList:			TStringList;
	ExclusiveFileList:	TStrings;
	PFileList:				^PChar;
	OrgCurDir1:				string;
	OrgCurDir2:				string;
	i:							integer;
	j:							integer;
begin
	ExclusiveFileList := nil;
	TempFileList      := TStringList.Create;
	ChDirEx( BaseDir,OrgCurDir1,OrgCurDir2 );
	try
		for j := Low( FileList ) to High( FileList ) do begin
			with FileList[j] do begin
				case VType of
					vtObject:
						if VObject is TStrings
						then begin
							TempFileList.AddStrings( VObject as TStrings );
						end;
					vtPointer:
						if VPointer <> nil
						then begin
							PFileList := VPointer;
							while PFileList^ <> nil do begin
								TempFileList.Add( PFileList^ );
								Inc( PFileList );
							end;
						end;
					vtPChar:
						TempFileList.Add( VPChar );
					vtString:
						TempFileList.Add( VString^ );
					vtAnsiString:
						TempFileList.Add( string( VAnsiString ));
{$IFNDEF VER90}	//	not Delphi 2 ?
					vtWideString:
						TempFileList.Add( string( VWideString ));
{$ENDIF}
					vtVariant:
						if VarIsArray( VVariant^ )
						then begin
							for i := VarArrayLowBound( VVariant^,1 ) to VarArrayHighBound( VVariant^,1 ) do begin
								TempFileList.Add( VVariant^[i] );
							end;
						end else begin
							TempFileList.Add( string( VVariant^ ));
						end;
				end;
			end;
		end;
		ExclusiveFileList := MakeFileList( Options,BaseDir,Options.jx  ,nil              ,nil         ,AbortFilter,False );
		Result            := MakeFileList( Options,BaseDir,TempFileList,ExclusiveFileList,ProgressProc,AbortFilter,True  );

		Options.r  := aoiUnassigned;	//	삪ς邩Ȃ߃NA
//$$$	Options.a  := aoiUnassigned;	//	̓NAĂ͂ȂȂ
		Options.jo := aosUnassigned;	//	͂ǂł悢
		Options.job:= aosUnassigned;	//	ǂł悢
		Options.p  := 1;					//	mɓ삳邽

	finally
		if OrgCurDir1<>'' then ChDir( OrgCurDir1 );
		if OrgCurDir2<>'' then ChDir( OrgCurDir2 );
		ExclusiveFileList.Free;
		TempFileList.Free;
	end;
end;

{$IFDEF VER90} // Delphi 2 ?
type
	EAssertionFailed = Exception;

procedure Assert( expr:Boolean;const msg:string );
begin
	if expr then exit;
	raise EAssertionFailed.Create( msg );
end;
{$ENDIF}

end.
