// A[JCoR|[lg for Delphi/C++Builder
// Common Archivers Component for Delphi/C++Builder
// Copyright(C) NORG1964/Masashi Yoneda 1997-2001
//
// YZ1֘AW[	YZ132.PAS
//
// v1.32:YZ1.DLL/YYZ32.DLLɂYZ1`ɂւ̑ΉJn
// v1.34:TYZ1 R}hC YZ1.DLL 0.20 / YYZ32.DLL 0.08
//       ʎdlɍ킹
//       TYZ1 gp DLL ̊Ojbg̕ύXɑΉ
//       TYZ1  YZ1.DLL ł̗O΍ǉ
// v1.35:TYZ1.Yz1  CmdLine ĂȂs̏C
//	      V YZ1.DLL ( [X )  y IvVɑΉ
// v1.38:DLL ̃Gg|Cg̎擾@ύX
// v1.39:YZ1.DLL  pX[h֘A API ւ̑Ήǉ
// v1.44:Delphi 6 ȍ~p WRITEABLECONST ̎w𖾎
// v1.48:gy nIvṼRgǉ
//
unit YZ132;	//	UnitYZ1ƃG[ɂȂ̂łނȂ

interface

uses
	Windows,
	SysUtils,
	Classes,
	Archives;

type
	TYZ1 = class( TArchiver )
	protected
		class procedure LoadDll; override;
		class procedure FreeDll; override;

	protected
		function  BuildCmdLine( Cmd,ArchiveFileName:string;Options:TArchiverOptions;Path:String;FileList:array of const;UseResFile:boolean ):String;

		function  FindOpen ( Handle:HWND;ArchiveFileName:string;dwMode:DWORD ):THARC; override;
		function  FindFirst( hArc:THArc;var IndivisualInfo:TIndivisualInfo;FileMask:string ):integer; override;
		function  FindNext ( hArc:THArc;var IndivisualInfo:TIndivisualInfo				   ):integer; override;
		function  FindClose( hArc:THArc													   ):integer; override;

	public
		function Yz1( Handle:HWND;cmdline:string;var Output:string ):integer;
		function UnpackFiles  ( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;DstPath:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer; override;
		function PackFiles    ( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;BaseDir:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer; override;
//		function RemoveItems  ( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;BaseDir:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer; override;
		function MakeSfx      ( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;DstPath:String                                           ;var Output:string ):Integer; override;
//		function UnpackToMem  ( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;FileName:string;lpvBuffer:LPVOID;dwSize:DWORD;lpdwWriteSize:LPDWORD   ):Integer; override;
		function CheckArchive ( ArchiveFileName:string;CheckMode:integer;CheckOptions:integer ):DWORD; override;

		function SetOwnerWindowEx ( Handle:HWND;lpArcProc:LPARCHIVERPROC ):boolean; override;
		function KillOwnerWindowEx( Handle:HWND                          ):boolean; override;
	end;

	function IsYz1Archive( ArchiveFileName:string ):boolean;

{$WRITEABLECONST ON}

const
	Yz1DllName1:	PChar = 'YYZ32.DLL';
	Yz1DllName2:	PChar = 'YZ1.DLL';

implementation

uses
	Filters;

type
	TYz1DLLSetDefaultPassword     = function( hArc:THArc;lpszPassword:PAnsiChar ):integer; stdcall;
	TYz1DLLPasswordDialog         = function( hwndParent:HWND;lpszPassword:PAnsiChar;dwSize:DWORD ):integer; stdcall;

	TYZ1Dll = class( TArchiverDll )
	private
	protected
		FHandle:							HWND;
		FSetDefaultPassword:			FARPROC;
		FPasswordDialog:				FARPROC;
	public
		function OpenArchive( Handle:HWND;ArchiveFileName:string;dwMode:DWORD ):THARC; override;
		function FindFirst( hArc:THArc;FileMask:string;IndivisualInfo:PIndivisualInfo ):integer; override;
		function SetDefaultPassword( hArc:THArc;lpszPassword:PAnsiChar ):integer;
		function EnterPassword( hwndParent:HWND;lpszPassword:PAnsiChar;dwSize:DWORD ):integer;
	end;

//---------------------------------------------------------------------
var
	FArchiver:		TArchiverDLL;

function Yz1DllName:string;
begin
	if( Yz1DllName1 <> nil )and( Yz1DllName2 <> nil )
	then begin
		result := Yz1DllName1 + '  ' + Yz1DllName2;
	end else begin
		if( Yz1DllName1 <> nil ) then result := Yz1DllName1;
		if( Yz1DllName2 <> nil ) then result := Yz1DllName2;
	end;
end;

procedure LoadDll;
begin
	if Assigned( FArchiver ) then exit;

	if Assigned( Yz1DllName1 )
	then begin
		try
			FArchiver := TYZ1Dll.Create( 'YZ1 `',Yz1DllName1,'Yz1' );
			FArchiver.LoadDLL;
			exit;
		except
			FArchiver.Free;
			FArchiver := nil;
		end;
	end;
	if Assigned( Yz1DllName2 )
	then begin
		try
			FArchiver := TYZ1Dll.Create( 'YZ1 `',Yz1DllName2,'Yz1' );
			FArchiver.LoadDLL;
			exit;
		except
			FArchiver.Free;
			FArchiver := nil;
		end;
	end;
	raise EArchiver.Create( 'Yz1 `ɂɂ '+Yz1DllName+' KvłB' );
end;

procedure FreeDll;
begin
	FArchiver.Free;
	FArchiver := nil;
end;

//---------------------------------------------------------------------
class procedure TYZ1.LoadDll;
begin
	YZ132.LoadDll;
end;

class procedure TYZ1.FreeDll;
begin
	YZ132.FreeDll;
end;

function TYZ1.UnpackFiles( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;DstPath:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer;
begin
	FCmdLine := BuildCmdLine( 'x',ArchiveFileName,Options,DstPath,FileList,UseResFile );
	result := Yz1( Handle,FCmdLine,Output );
end;

function TYZ1.PackFiles( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;BaseDir:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer;
begin
	FCmdLine := BuildCmdLine( 'c',ArchiveFileName,Options,BaseDir,FileList,UseResFile );
	result := Yz1( Handle,FCmdLine,Output );
end;
{
function TYZ1.RemoveItems( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;BaseDir:String;FileList:array of const;UseResFile:boolean;var Output:string ):Integer;
begin
	FCmdLine := BuildCmdLine( 'd',ArchiveFileName,Options,'',FileList,ruOnRemoveItem in Options.ResFileUsage );
	result := Yz1( Handle,FCmdLine,Output );
end;
}
function TYZ1.MakeSfx( Handle:HWND;ArchiveFileName:string;Options:TArchiverOptions;DstPath:String;var Output:string ):Integer;
var
	SfxDat:		array[0..511] of char;
	SfxName:		string;
	SfxHead:		TFileStream;
	SfxFile:		TFileStream;
	ArcFile:		TFileStream;
	P:				PAnsiChar;
	SfxDecoder:	string;
	dwFileSize:	DWORD;
begin
	if Options.gw > 0
	then begin
		SfxDecoder := 'yzw32cui.sfx';
		if SearchPath( nil,PChar( SfxDecoder ),nil,SizeOf( SfxDat ),SfxDat,P ) = 0
		then begin
			SfxDecoder := 'yzdec.exe';
			if SearchPath( nil,PChar( SfxDecoder ),nil,SizeOf( SfxDat ),SfxDat,P ) = 0
			then begin
				raise EArchiver.Create( 'yz1 ɂWin32ȉ𓀏ɂ̍쐬ɂ yzw32cui.sfx  yzdec.exe KvłB' );
			end;
		end;
	end else begin
		SfxDecoder := 'yzdos16.sfx';
		if SearchPath( nil,PChar( SfxDecoder ),nil,SizeOf( SfxDat ),SfxDat,P ) = 0
		then raise EArchiver.Create( 'yz1 ɂDOSȉ𓀏ɂ̍쐬ɂ '+SfxDecoder+' KvłB' );
	end;
	SfxName := ChangeFileExt( ArchiveFileName,'.exe' );
	if DstPath <> ''
	then begin
		SfxName := ExtractFileName( SfxName );
		SfxName := MakeFileName( DstPath,SfxName );
	end;
	ArcFile := TFileStream.Create( ArchiveFileName,fmOpenRead+fmShareDenyWrite );
	SfxFile := TFileStream.Create( SfxName        ,fmCreate                    );
	SfxHead := TFileStream.Create( SfxDat         ,fmOpenRead+fmShareDenyWrite );
	dwFileSize := ArcFile.Size;
	dwFileSize := (( dwFileSize and $000000FF ) shl 24 )
				  or (( dwFileSize and $0000FF00 ) shl  8 )
				  or (( dwFileSize and $00FF0000 ) shr  8 )
				  or (( dwFileSize and $FF000000 ) shr 24 );
	try
		SfxFile.CopyFrom( SfxHead,0 );
		SfxFile.CopyFrom( ArcFile,0 );
		SfxFile.WriteBuffer( dwFileSize,sizeof( dwFileSize ));
	finally
		ArcFile.Free;
		SfxFile.Free;
		SfxHead.Free;
	end;
	result := 0;
end;

function TYZ1.CheckArchive( ArchiveFileName:string;CheckMode:integer;CheckOptions:integer ):DWORD;
begin
	result := FArchiver.CheckArchive( PChar( ArchiveFileName ),CheckMode+CheckOptions );
end;

function TYZ1.SetOwnerWindowEx ( Handle:HWND;lpArcProc:LPARCHIVERPROC ):boolean;
begin
	inherited SetOwnerWindowEx( Handle,lpArcProc );
	result := FArchiver.SetOwnerWindowEx( Handle,lpArcProc );
end;

function TYZ1.KillOwnerWindowEx( Handle:HWND ):boolean;
begin
	result := FArchiver.KillOwnerWindowEx( Handle );
	inherited KillOwnerWindowEx( Handle );
end;

function TYZ1.Yz1( Handle:HWND;CmdLine:string;var Output:string ):integer;
begin
	try
		result := FArchiver.ArchiverProc( Handle,PChar( CmdLine ),PAnsiChar( Output ),Length( Output ));
	except
		EnableWindow( Handle,True );	//	YZ1.DLL ŗOADisable ̂܂܋A邱Ƃ
		raise;
	end;
end;

function TYZ1.BuildCmdLine( Cmd,ArchiveFileName:string;Options:TArchiverOptions;Path:String;FileList:array of const;UseResFile:boolean ):String;
var
	CmdLine:	TCmdOpt;
	opt_c:	integer;
	opt_y:	integer;
begin
	with Options do begin
		CmdLine := TCmdOpt.Create;

		opt_c := c;
		opt_y := aoiUnassigned;
		case m of
			0:		opt_y := 2;		//	
			1:		opt_y := 1;		//	S Yes
			2:		opt_y := 2;		//	gqύXēWJ - no support
			9:		opt_y := 0;		//	S No
//			else	opt_y := 2;		//	Ƃ肠S₵Ƃ
		end;
		if opt_y = 2 then opt_c := 2;

		CmdLine.Add( '-+' );			//	ɃWXg̐ݒ𖳎

//		CmdLine.AddBolOpt( 'a'	,a > 0 );	//	a[0|1|2]				̍ČB
		CmdLine.AddIntOpt( 'c'	,opt_c );	//	c[0|1]				^CX^vȗ
////	CmdLine.AddIntOpt( 'd'	,d	 );		//	d[0|1]				fBNg̊i[
//		CmdLine.AddIntOpt( 'e'	,e	 );		//	e[0|1]				TCY𔼕ɂĈk
//		CmdLine.AddIntOpt( 'f'	,f	 );		//	f[0|1]				fBXNcʃ`FbN̒~
//		CmdLine.AddIntOpt( 'h'	,h	 );		//	h[0|1|2|3]			wb_̌`w
//		CmdLine.AddIntOpt( 'i'	,i	 );		//	i[0|1|2]				t@CIő啶Ə
//		CmdLine.AddIntOpt( 'l'	,l	 );		//	l[0|1|2]				WJÕt@C̕\@̕ύX
		CmdLine.AddIntOpt( 'y',opt_y );		//	m[0|1|2]				 yes Ɖ
		CmdLine.AddBolOpt( 'i',( n > 0 )or( CallbackEnabled ));
														//	n[0|1]				WJ󋵃_CAO\̗}~
//		CmdLine.AddIntOpt( 'o'	,o	 );		//	o[0|1|2]				`ŏɂ쐬
		CmdLine.AddIntOpt( 'z'	,p	 );		//	p[0|1|2]				SpXōv
//		CmdLine.AddBolOpt( 'r'	,r	> 0 );	//	r[0|1|2]				ċAI
//		CmdLine.AddIntOpt( 's'	,s	 );		//	s[0|1]				XLbv\̗}
//		CmdLine.AddIntOpt( 't'	,t	 );		//	t[0|1]				ɂ̍XV̎w
//
//		CmdLine.AddIntOpt( 'u'	,u	  );		//	u[0|1]				t@C̍XViV́j
//		CmdLine.AddPath1 ( 'w'  ,w   );		//	w[0|1|<Dir>]		ƗpfBNg̎w
		CmdLine.AddIntOpt( 'x'	,x   );		//	x[0|1]				fBNgLɂ
//		CmdLine.AddIntOpt( 'y'	,y	  );		//	y[0|1]				SĂ̎ yes Ɖ
//		CmdLine.AddIntOpt( 'z'	,z	  );		//	z[0|1|2|<gq>]	kt@C̎w			###gq̓T|[gȂ###
//		CmdLine.AddIntOpt( 'jc' ,jc  );		//	jc[0|1]				jwb_𖳎
//		CmdLine.AddIntOpt( 'jd' ,jd  );		//	jd[<TCY>]		fBXN̋󂫗eʂmF
//		CmdLine.AddIntOpt( 'je' ,je  );		//	je[<TCY>]		Huffman obt@̑傫w
//		CmdLine.AddIntOpt( 'jf' ,jf  );		//	jf[0|1]				[gL̍폜
//		CmdLine.AddIntOpt( 'jh' ,jh  );	 	//	jh[0|1]				WindowsNT/95 p̃}[Nɂɕt
//		CmdLine.AddIntOpt( 'ji' ,ji  );		//	ji[0|1]				Zt@CŊi[
//		CmdLine.AddIntOpt( 'l'  ,jm  );		//	jm[0|1|2|3|4]		k`w
//		CmdLine.AddIntOpt( 'jn' ,jn  );		//	jn[0|1]				VKt@Ĉ
//		CmdLine.AddStrOpt( 'jo' ,jo  );		//	jo[<w>]		YYMMDDHHMMSS ̓tȍ~
//		CmdLine.AddStrOpt( 'job',job );		//	job[<w>]	YYMMDDHHMMSS ̓tȑO
//		CmdLine.AddIntOpt( 'jp' ,jp  );		//	jp[0|1]				io[vOXEo[ŕ\
//		CmdLine.AddIntOpt( 'jr' ,jr  );		//	jr[0|1]				t@C̒u
//		CmdLine.AddIntOpt( 'jss',jss );		//	jss[0|1]				kt@CI[vG[𖳎BʏCkɈkΏۃt@
//		CmdLine.AddIntOpt( 'jw' ,jw  );		//	jw[0|1|2|3|4]		WinSFX/WinSFXM 쐬
//		CmdLine.AddFList2( 'jx' ,[jx] );		//	jx[<t@C>]	Ot@C
//		CmdLine.AddIntOpt( 'jyc',jyc );		//	jyc[0|1]				fBNg쐬̊mFȗ
//		CmdLine.AddIntOpt( 'jyd',jyd );		//	jyd[0|1]				t@C폜̊mFȗ
//		CmdLine.AddIntOpt( 'jyk',jyk );		//	jyk[0|1]				gpłfBXNeʂ̊mF̏ȗ
//		CmdLine.AddIntOpt( 'jyn',jyn );		//	jyn[0|1]				Vt@C̗v̏ȗ
//		CmdLine.AddIntOpt( 'jyo',jyo );		//	jyo[0|1]				t@Cւ̏㏑mF̏ȗ
//		CmdLine.AddStrOpt( 'jz' ,jz  );		//	jz[<t@C>]	t@C߂̃t@C
//		CmdLine.AddIntOpt( 'ga' ,ga  );		//	ga[0|1]				ݕs𖳎
//		CmdLine.AddIntOpt( 'gd' ,gd  );		//	gd[0|1]				]ȃf[^̍폜
//		CmdLine.AddIntOpt( 'ge' ,ge  );		//	ge[0|1]				ŏ̊gqF
//		CmdLine.AddIntOpt( 'gf' ,gf  );		//	gf[0|1|2]			łɂt@C̍XV
//		CmdLine.AddIntOpt( 'gj' ,gj  );		//	gj[0|1]				x ߂ e ߂ƓlƌȂ
//		CmdLine.AddIntOpt( 'gm' ,gm  );		//	gm[0|1]				G[bZ[W\̗}~
//		CmdLine.AddIntOpt( 'gn' ,gn  );		//	gn[0|1|2]			WJt@C̍vTCY 100% ƂiOt̕\
//		CmdLine.AddIntOpt( 'go' ,go  );		//	go[0|1]				_CAÕI[i[EBhE̎w
//		CmdLine.AddIntOpt( 'gp' ,gp  );		//	gp[0|1]				EBhE Disable ɂȂ
//		CmdLine.AddStrOpt( 'gr' ,gr  );		//	gr[<t@C>]	ύXt@C
//		CmdLine.AddIntOpt( 'gs' ,gs  );		//	gs[<TCY>]		wb_TCY̎w
//		CmdLine.AddIntOpt( 'gu' ,gu  );		//	gu[0|1]				WinSFXCDosSFX ɑSẴt@Ci[
//		CmdLine.AddIntOpt( 'gw' ,gw  );		//	gw[0|1|2|3|4]		WinSFX32/WinSFX32M 쐬
//		CmdLine.AddIntOpt( 'gya',gya );		//	gya[0|1]				  [-gya1]
//		CmdLine.AddIntOpt( 'gyc',gyc );		//	gyc[0|1]				^CX^v`FbN̏ȗ  [-gyc1]
//		CmdLine.AddStrOpt( 'gyd',gyd );		//	gyd<fBNg>	𓀐fBNgw
//		CmdLine.AddStrOpt( 'gye',gye );		//	gye<R}h>		sR}hw
//		CmdLine.AddIntOpt( 'gyo',gyo );		//	gyo[0|1]				㏑w(㏑mFsȂ)  [-gyo0]
//		CmdLine.AddIntOpt( 'gyq',gyq );		//	gyq[0|1]				sw  [-gyq0]
//		CmdLine.AddIntOpt( 'gys',gys );		//	gys[0|1]				₃`FbNs  [-gys0]
//		CmdLine.AddStrOpt( 'gyt',gyt );		//	gyt<^Cg>		𓀐fBNg^Cg̐ݒ
//		CmdLine.AddStrOpt( 'gyw',gyw );		//	gyw<^Cg>		_CAÕ^Cg̐ݒ
//		CmdLine.AddIntOpt( 'gyx',gyx );		//	gyx[0|1]				fBNg̕s  [-gyx0]

		CmdLine.Add( UserOptions );

		AddFileSpec1( CmdLine,ArchiveFileName,Path );
		AddFileSpec2( CmdLine,Options,FileList,UseResFile );

		result := cmd + CmdLine.Str;
		CmdLine.Free;
	end;
end;

function TYZ1.FindOpen( Handle:HWND;ArchiveFileName:string;dwMode:DWORD ):THARC;
begin
	result := FArchiver.OpenArchive( Handle,PChar( ExpandFileName( ArchiveFileName )),dwMode );
end;

function TYZ1.FindClose( hArc:THArc ):integer;
begin
	result := FArchiver.CloseArchive( hArc );
end;

function TYZ1.FindFirst( hArc:THArc;var IndivisualInfo:TIndivisualInfo;FileMask:string ):integer;
begin
	result := FArchiver.FindFirst( hArc,PChar( FileMask ),@IndivisualInfo );
end;

function TYZ1.FindNext( hArc:THArc;var IndivisualInfo:TIndivisualInfo ):integer;
begin
	result := FArchiver.FindNext( hArc,@IndivisualInfo )
end;

//	function IsYz1Archive( ArchiveFileName:string ):boolean;
//	var
//		SfxType:	integer;
//	begin
//		try
//			LoadDll;
//			SfxType:= Yz1CheckArchive( PChar( ExpandFileName( ArchiveFileName )),CHECKARCHIVE_SFX+CHECKARCHIVE_ALL );
//			result := ( SfxType <> -1 );
//		except
//			result := false;
//		end;
//	end;

function IsYz1Archive( ArchiveFileName:string ):boolean;
var
	hArc:		THARC;
begin
	try
		LoadDLL;
		ArchiveFileName := ExpandFileName( ArchiveFileName );
		result := false;
		if not FileExists( ArchiveFileName ) then exit;
		hArc := FArchiver.OpenArchive( 0,PAnsiChar( ArchiveFileName ),M_REGARDLESS_INIT_FILE+M_ERROR_MESSAGE_OFF );
		FArchiver.CloseArchive( hArc );
		result := ( hArc <> 0 );
	except
		result := false;
	end;
end;

{ TYZ1Dll }

function TYZ1Dll.OpenArchive( Handle:HWND;ArchiveFileName:string;dwMode:DWORD ):THARC;
begin
	FHandle := Handle;
	result := inherited OpenArchive( Handle,PAnsiChar( ArchiveFileName ),dwMode );
end;

function TYZ1Dll.FindFirst( hArc:THArc;FileMask:string;IndivisualInfo:PIndivisualInfo ):integer;
var
	szPassword:	array[0..255] of AnsiChar;
	i:				integer;
begin
	for i := 0 to 3 do begin
		result := inherited FindFirst( hArc,PAnsiChar( FileMask ),IndivisualInfo );
		if result <> ERROR_PASSWORD_FILE then break;
		if EnterPassword( FHandle,szPassword,sizeof( szPassword )) < 0 then exit;
		SetDefaultPassword( hArc,szPassword );
	end;
end;

function TYZ1Dll.SetDefaultPassword( hArc:THArc;lpszPassword:PAnsiChar ):integer;
begin
	if GetProcAddr( FSetDefaultPassword,FhDLL,FEntryPrefix+'SetDefaultPassword',false ) = false
	then begin
		Result := -1;
		exit;
	end;
	result := TYz1DLLSetDefaultPassword( FSetDefaultPassword )( hArc,lpszPassword );
end;

function TYZ1Dll.EnterPassword( hwndParent:HWND;lpszPassword:PAnsiChar;dwSize:DWORD ):integer;
begin
	if GetProcAddr( FPasswordDialog,FhDLL,FEntryPrefix+'PasswordDialog',false ) = false
	then begin
		Result := -1;
		exit;
	end;
	result := TYz1DLLPasswordDialog( FPasswordDialog )( hwndParent,lpszPassword,dwSize );
end;

end.
